#!/bin/sh
# ======================================================================

# this is a shell script to operate a global search on the basis
# of genetic algorithms

rm -f genetic_$1.log fitfile elite solutions
touch genetic_$1.log

echo " -----------------------------------------------" 
echo "             GENETIC ALGORITHMS" 
echo "        Authors: R. Doell, LBL, 1995" 
echo "     E. Landree, C. Collazo, L. D. Marks, NU" 
echo "   Acta Crystallographica B 53, 916-922 (1997)"  
echo "     Version 6.0   creation date: 12/30/03" 
echo " -----------------------------------------------" 
echo 

echo " -----------------------------------------------" >> genetic_$1.log
echo "             GENETIC ALGORITHMS" >> genetic_$1.log
echo "        Authors: R. Doell, LBL, 1995" >> genetic_$1.log
echo "     E. Landree, C. Collazo, L. D. Marks, NU" >> genetic_$1.log
echo "   Acta Crystallographica B 53, 916-922 (1997)"  >> genetic_$1.log
echo "     Version 6.0   creation date: 12/30/03" >> genetic_$1.log
echo " -----------------------------------------------" >> genetic_$1.log
echo >> genetic_$1.log

echo " -------------------------------------------------------" >> genetic_$1.log
echo " Generating three random starting populations ....." >> genetic_$1.log
echo " Generating three random starting populations ....." 
echo " -------------------------------------------------------" >> genetic_$1.log

#cute program 'sconf' with input file 'control'.
# the output file 'population' contains the starting population coded as
# 1's and 0's. output file 'bithelp' contains the number of bits to describe
# one chromosome.

sconf2

read word1 word2 < error
if [ $word1 = error ]
   then
        echo " genal.shell aborted due to error in 'sconf'"
        exit
fi
rm -f error

echo >> genetic_$1.log
randpopx >> genetic_$1.log
echo >> genetic_$1.log
echo " -------------------------------------------------------" >> genetic_$1.log
echo " Calculating fitness for first 3 populations ....." >> genetic_$1.log
#echo " Calculating fitness for first 3 populations ....."
echo " -------------------------------------------------------" >> genetic_$1.log
echo >> genetic_$1.log
#cp ../Start/pop_* ./
cp pop_1 population


# translate digital code of population back to 'real' parameters
#cute program 'transl' with input 'control' and 'population'
# and output 'popw'

transl2


# get number of parameters from file 'control'
           grep nparam control > temp
           read nparam rest < temp
           rm -f temp

# get number of chromosomes from file 'control'
           grep nchild control > temp
           read nchild rest < temp
           rm -f temp

# get number of children from file 'control'
           grep nchild control > temp
           read nchild rest < temp
           rm -f temp

# get tension for cross.f from 'control'
           grep tension control > temp
           read tension rest < temp
           rm -f temp


# =====================================================================
# initialize loop over chromosomes
# From control file
# Number of parameters
    echo $nparam > sref.control
# Number of members for this population
    echo $nchild >> sref.control
# Which population ?
    echo "0" >> sref.control
# Total number of bits
    read totbits < bithelp
    echo $totbits >> sref.control
#
fs2D_pop $1 > phase.log

# =====================================================================

# file 'fitfile' contains all chromosomes with fitness and binary code
    sort -n -o store.tmp fitfile
    uniq store.tmp > fit_1
    cp pop_2 population ; transl2
    rm -f fitfile
    fs2D_pop $1 > phase.log
    sort -n -o store.tmp fitfile
    uniq store.tmp > fit_2
    cp pop_3 population ; transl2
    rm -f fitfile
    fs2D_pop $1 > phase.log
    sort -n -o store.tmp fitfile
    uniq store.tmp > fit_3


# count total number of investigated chromosomes
ncount=`expr $nchild + $nchild + $nchild`

# initialize loop over populations

# get number of new children from file 'control'
           grep nchild control > temp
           read nchild rest < temp
           rm -f temp

# get maximum number of populations from file 'control'
           grep npop control > temp
           read npop rest < temp
           rm -f temp

# get number of surviving parents from file 'control'
           grep nsurv control > temp
           read nsurv rest < temp
           rm -f temp
 
# make sure nindiv is set to correct value           
           grep nchild control > temp
           read nindiv rest < temp
           rm -f temp
           
# initialize solution files 
           grep nsave control > temp
           read nsave rest < temp
           rm -f temp
	   sort -u fit_1 fit_2 fit_3 | head -$nsave > solutions
# Add solutions to initial fit files (?)
#        sort -u fit_1 solutions > t1 ; mv t1 fit_1
#        sort -u fit_2 solutions > t2 ; mv t2 fit_2
#        sort -u fit_3 solutions > t3 ; mv t3 fit_3
           
popc=1
#    calculate average fitness of present population
#    input files: 'helpfile', 'fitfile'
#    output file containing value of average fitness: 'helpfile2'

npp=1
while [ "$popc" -lt "$npop" ]
do 

np=1
while [ "$np" -lt "4" ]
do
   cp fit_$np fitfile
   echo $nparam > helpfile
   echo $nindiv >> helpfile

   avfit
   
   head -1 fitfile > temp
   read bf rest < temp
   rm -f temp
   
   echo  " Highest fitness subpop $np : $bf " >> genetic_$1.log
#   echo $bf >> genetic_$1.log
   read var1 var2 < helpfile2
#   echo $var1 >> genetic_$1.log
   echo  " Average fitness of population $popc subpop $np  : $var1" >> genetic_$1.log
#   echo  " number of chromosomes investigated up to now: $ncount" >> genetic_$1.log
   echo  " Average fitness of population $popc subpop $np : $var1"
   
   stat98 >> genetic_$1.log

echo >> genetic_$1.log
echo " ---------------------------------------------------------" >> genetic_$1.log
echo " Performing crossover and mutation in population $popc ..." >> genetic_$1.log
echo " Using shared crossover mode $npp" >> genetic_$1.log
echo " ---------------------------------------------------------" >> genetic_$1.log

#    crossover: input files: 'bithelp', 'control' and 'fitfile'
#               output file: 'lpop' (containing new large population)
   echo $nindiv >> bithelp
   grep idum control >> bithelp

   cross_share"$npp"F $tension >> genetic_$1.log

# Debug
#  cp cross"$np".check Cross_"$popc"
#    mutation: input files 'bithelp', 'control' and 'lpop'
#              output: 'mpop' (containing mutated population)
   mutate


#    Increase counter for total number of investigated chromosomes
#    This is no longer a very precise count, just approximate
ncount=`expr $ncount + $nchild`

# =====================================================================
#   mv mpop population
#   Changed to add mutants to population being considered
    sort -u mpop lpop > population   
#    initialize loop over chromosomes
 
# get number of parameters from file 'control'
# To make sure nparam is set correctly
           grep nparam control > temp
           read nparam rest < temp
           rm -f temp

# Generate seed, only different values
grep seed control > temp
read nseed rest < temp
rm -f temp
seed2=`expr $nsave + $nsave + $nsave + $nsave`
sort -k 2,100 calc2.log | uniq | head -$seed2 > sorted
merger sorted seed.tmp
sort -k 2,2 seed.tmp | uniq > seed.tmp2
sort seed.tmp2 | head -$nseed > seed.tmp
rm -f seed.tmp2
           
# Elite every other cycle
rm -f fitfile
if [ -r elite ]
then
# Only use solutions which are different final points
wc -l seed.tmp > temp
read nelite rest < temp
if [ "$nelite" -lt "10" ]
then
 echo " WARNING: only $nelite different top solutions" >> genetic_$1.log
 nsave=`expr $nsave + 20`
 echo " Increasing size of solutions file to $nsave" >> genetic_$1.log
fi
ne=1
rm -f elite
while [ "$ne" -le "$nelite" ]
  do
    head -$ne seed.tmp | tail -1 > temp
    read efind rest < temp
    grep -e $efind solutions >> elite
    ne=`expr $ne + 1`
  done
head -$nsurv elite > fitfile
rm -f elite
else
# Add seeds to population
head -$nseed seed.tmp >> population
touch elite
fi

# translate mutated children to real parameters to go into the file popw
rm -f popw
transl
# =====================================================================
# initialize loop over chromosomes
# Control file
# Number of parameters
    echo $nparam > sref.control
# Number of members for this population
    wc -l popw > temp ; read ntemp rest < temp ; rm -f temp
    echo $ntemp >> sref.control
# Which population ?
    echo $popc >> sref.control
# Total number of bits
    read totbits < bithelp
    echo $totbits >> sref.control
#
fs2D_pop $1 > phase.log
# =====================================================================


# create new 'fitfile' from which next parents are chosen
grep nchild control > temp ; read nindiv rest < temp ; rm -f temp
# sort, keeping one duplicate
    sort -n fitfile | uniq > store.tmp
    sort -n -o store.tmp2 fitfile
    comm -13 store.tmp store.tmp2 > store.tmp3
    sort -n store.tmp3 | uniq > store.tmp4
    sort -n -o store store.tmp4 store.tmp
    mv store fitfile
#    mv store.tmp fitfile    
# update solutions and elite files
	sort -n fitfile solutions | uniq > solutions.tmp
	head -$nsave solutions.tmp > solutions
	cp fitfile fit_$np

# Increment subpopulation counter
np=`expr $np + 1`
# Increment counter for which version of cross to use
npp=`expr $npp + 1`
if [ "$npp" -gt "6" ]
then
        npp=1
fi
# Increment counter for populations
popc=`expr $popc + 1`
done
	
# survivors
           grep nsurv control > temp
           read nsurv rest < temp
           rm -f temp

#           grep nsave control > temp
#           read nsave rest < temp
#           rm -f temp
           uniq solutions.tmp temp2  
           head -$nsave temp2 > solutions
           rm -f temp2

# end loop over populations
#  popc=`expr $popc + 1`
if test -e .stop ; then 
echo Termination Requestion
rm .stop
exit
fi

done

# =====================================================================

# final output


# calculate average fitness of final population
echo $nparam > helpfile
echo $nindiv >> helpfile
avfit

head -1 fitfile | read bf rest
echo  " Highest fitness in (final) population:  $bf" >> genetic_$1.log
read bf rest < helpfile2
echo  " Average fitness of (final) population $fpop : $bf" >> genetic_$1.log
# echo  " total number of chromosomes investigated: $ncount" >> genetic_$1.log

echo  " Average fitness of final population $fpop : $bf" 
stat98 >> genetic_$1.log

echo >> genetic_$1.log
echo " -------------------------------------------------------" >> genetic_$1.log
echo " Genetic Analysis Finished " >> genetic_$1.log
echo " Genetic Analysis Finished "
echo " -------------------------------------------------------" >> genetic_$1.log

# delete files not needed any more
     rm -f helpfile elite *.tmp sref.control
     rm -f bithelp
     rm -f store*
     rm -f popw pop_1 pop_2 pop_3 mpop
     rm -f helpfile*
     rm -f prot
     rm -f fitfile fit.last
     rm -f population lpop fit_1 fit_2 fit_3
     rm -f random.hold
     rm -f solutions.tmp junk*

